#property link      "www.forex-tsd.com"      
#property copyright "www.forex-tsd.com" 

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1  clrRed
#property indicator_color2  clrRoyalBlue

//
//
//
//
//

extern int    BodyThickness   = 2;
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsNotify    = false;
extern bool   alertsEmail     = false;
extern string soundFile       = "alert2.wav";

//
//
//
//
//

double Buffer1[];
double Buffer2[];
double Buffer3[];
double Buffer4[];
double trend[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//               

int init()
{
    IndicatorBuffers(5);
    SetIndexBuffer(0,Buffer3); SetIndexStyle(0,DRAW_HISTOGRAM,0,BodyThickness);
    SetIndexBuffer(1,Buffer4); SetIndexStyle(1,DRAW_HISTOGRAM,0,BodyThickness);
    SetIndexBuffer(2,Buffer1); 
    SetIndexBuffer(3,Buffer2);  
    SetIndexBuffer(4,trend); 
    IndicatorShortName("HA No wicks");   
return(0);
}

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int pos,limit;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);  
          
   //
   //
   //
   //
   //
   
     for (pos=limit; pos >= 0; pos--)
     {                    
         double haClose = (Open[pos]+High[pos]+Low[pos]+Close[pos])/4;
         double haOpen  = (Open[pos+1]+Close[pos+1])/2;
         double haHigh  = MathMax(High[pos],MathMax(haOpen,haClose));
         double haLow   = MathMin(Low[pos], MathMin(haOpen,haClose));
          
         if (haOpen<haClose) { Buffer1[pos]=haLow;  Buffer2[pos]=haHigh; } 
         else                { Buffer1[pos]=haHigh; Buffer2[pos]=haLow;  } 
                               Buffer3[pos]=haOpen; Buffer4[pos]=haClose;  
                               
         trend[pos] = trend[pos+1];
         if (Buffer3[pos] < Buffer4[pos]) trend[pos] =  1;
         if (Buffer3[pos] > Buffer4[pos]) trend[pos] = -1;  
      }
      
      //
      //
      //
      //
      //
      
      if (alertsOn)
      {
        if (alertsOnCurrent)
             int whichBar = 0;
        else     whichBar = 1;
        if (trend[whichBar] != trend[whichBar+1])
        {
           if (trend[whichBar] == 1) doAlert(whichBar,"up");
           if (trend[whichBar] ==-1) doAlert(whichBar,"down");
        }         
      } 
return(0);
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message = timeFrameToString(_Period)+" "+_Symbol+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" Heiken Ashi "+doWhat;
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Heiken Ashi "),message);
             if (alertsSound)   PlaySound(soundFile);
   }
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

   
   